<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'tId' => '\\StructType\\TId',
            'tIdNum' => '\\StructType\\TIdNum',
            'tVersionMensaje' => '\\StructType\\TVersionMensaje',
            'tIdRemitente' => '\\StructType\\TIdRemitente',
            'tFecha' => '\\StructType\\TFecha',
            'tFechaHora' => '\\StructType\\TFechaHora',
            'tTerminoFijo' => '\\StructType\\TTerminoFijo',
            'tTerminoVariable' => '\\StructType\\TTerminoVariable',
            'tGradiente' => '\\StructType\\TGradiente',
            'tUnidad' => '\\StructType\\TUnidad',
            'tPeriodo' => '\\StructType\\TPeriodo',
            'tCantidad' => '\\StructType\\TCantidad',
            'tCantidadSinMax' => '\\StructType\\TCantidadSinMax',
            'tPrecio' => '\\StructType\\TPrecio',
            'tPrecioNegativo' => '\\StructType\\TPrecioNegativo',
            'tIntervaloTiempo' => '\\StructType\\TIntervaloTiempo',
            'tCodTransaccion' => '\\StructType\\TCodTransaccion',
            'tIdPrograma' => '\\StructType\\TIdPrograma',
            'tCodConsulta' => '\\StructType\\TCodConsulta',
            'tIdioma' => '\\StructType\\TIdioma',
            'tSegmento' => '\\StructType\\TSegmento',
            'tSesionAnotaciones' => '\\StructType\\TSesionAnotaciones',
            'tSignoImp' => '\\StructType\\TSignoImp',
            'tSignoEne' => '\\StructType\\TSignoEne',
            'tCodigo' => '\\StructType\\TCodigo',
            'tCuenta' => '\\StructType\\TCuenta',
            'tRespuesta' => '\\StructType\\TRespuesta',
            'CodigoRespuesta' => '\\StructType\\CodigoRespuesta',
            'tAgente' => '\\StructType\\TAgente',
            'tNudo' => '\\StructType\\TNudo',
            'tIdGrupoEmpresarial' => '\\StructType\\TIdGrupoEmpresarial',
            'tIdEmpresa' => '\\StructType\\TIdEmpresa',
            'tImporte' => '\\StructType\\TImporte',
            'tCodSubasta' => '\\StructType\\TCodSubasta',
            'tCodProducto' => '\\StructType\\TCodProducto',
            'tTipoProducto' => '\\StructType\\TTipoProducto',
            'tMercado' => '\\StructType\\TMercado',
            'tUniEnergia' => '\\StructType\\TUniEnergia',
            'tUniMonetaria' => '\\StructType\\TUniMonetaria',
            'tUniPrecio' => '\\StructType\\TUniPrecio',
            'tUniGradiente' => '\\StructType\\TUniGradiente',
            'tClaseOferta' => '\\StructType\\TClaseOferta',
            'tTipoTransaccion' => '\\StructType\\TTipoTransaccion',
            'tAgregacion' => '\\StructType\\TAgregacion',
            'tSiNo' => '\\StructType\\TSiNo',
            'tTipoConsulta' => '\\StructType\\TTipoConsulta',
            'tTipoDescarga' => '\\StructType\\TTipoDescarga',
            'tTipoCasacion' => '\\StructType\\TTipoCasacion',
            'tTipoContrato' => '\\StructType\\TTipoContrato',
            'tTipoResponsableCostes' => '\\StructType\\TTipoResponsableCostes',
            'tFrontera' => '\\StructType\\TFrontera',
            'tClaseOfertaAnotacion' => '\\StructType\\TClaseOfertaAnotacion',
            'tTipoUnidadLiq' => '\\StructType\\TTipoUnidadLiq',
            'tEstadoLiq' => '\\StructType\\TEstadoLiq',
            'FechaHoraResponse' => '\\StructType\\FechaHoraResponse',
            'tMensajeEjecucionConsulta' => '\\StructType\\TMensajeEjecucionConsulta',
            'Parametros' => '\\StructType\\Parametros',
            'Txt' => '\\StructType\\Txt',
            'Num' => '\\StructType\\Num',
            'Fec' => '\\StructType\\Fec',
            'Ses' => '\\StructType\\Ses',
            'RespuestaEjecucionConsultaEncolumnadaResponse' => '\\StructType\\RespuestaEjecucionConsultaEncolumnadaResponse',
            'tRespuestaEjecucionConsultaEncolumnada' => '\\StructType\\TRespuestaEjecucionConsultaEncolumnada',
            'Agregados' => '\\StructType\\Agregados',
            'Feh' => '\\StructType\\Feh',
            'Hor' => '\\StructType\\Hor',
            'Fila' => '\\StructType\\Fila',
            'RespuestaEjecucionConsultaAnexoResponse' => '\\StructType\\RespuestaEjecucionConsultaAnexoResponse',
            'tRespuestaEjecucionConsultaAnexo' => '\\StructType\\TRespuestaEjecucionConsultaAnexo',
            'AtributosFicheroAnexo' => '\\StructType\\AtributosFicheroAnexo',
            'Nombre' => '\\StructType\\Nombre',
            'Tamano' => '\\StructType\\Tamano',
            'tMensajePrecios' => '\\StructType\\TMensajePrecios',
            'IdPrecio' => '\\StructType\\IdPrecio',
            'Sesion' => '\\StructType\\Sesion',
            'tSerieTemporalPrecios' => '\\StructType\\TSerieTemporalPrecios',
            'tPeriodoPrecios' => '\\StructType\\TPeriodoPrecios',
            'tValPrecios' => '\\StructType\\TValPrecios',
            'tMensajeProgramas' => '\\StructType\\TMensajeProgramas',
            'tSerieTemporalPrograma' => '\\StructType\\TSerieTemporalPrograma',
            'IdTransaccion' => '\\StructType\\IdTransaccion',
            'tPeriodoPrograma' => '\\StructType\\TPeriodoPrograma',
            'tValPrograma' => '\\StructType\\TValPrograma',
            'tMensajeHorasAnuladas' => '\\StructType\\TMensajeHorasAnuladas',
            'IdHorasAnuladas' => '\\StructType\\IdHorasAnuladas',
            'tSerieTemporalHorasAnuladas' => '\\StructType\\TSerieTemporalHorasAnuladas',
            'tPeriodoHorasAnuladas' => '\\StructType\\TPeriodoHorasAnuladas',
            'tValHorasAnuladas' => '\\StructType\\TValHorasAnuladas',
            'tMensajeAnotaciones' => '\\StructType\\TMensajeAnotaciones',
            'tAnotacionesEmpresa' => '\\StructType\\TAnotacionesEmpresa',
            'tSerieTemporalAnotaciones' => '\\StructType\\TSerieTemporalAnotaciones',
            'tPeriodoAnotaciones' => '\\StructType\\TPeriodoAnotaciones',
            'tValAnotación' => '\\StructType\\TValAnotación',
            'RespuestaEjecucionConsultaProgramaResponse' => '\\StructType\\RespuestaEjecucionConsultaProgramaResponse',
            'tRespuestaEjecucionConsultaPrograma' => '\\StructType\\TRespuestaEjecucionConsultaPrograma',
            'RespuestaConfiguracionConsultaResponse' => '\\StructType\\RespuestaConfiguracionConsultaResponse',
            'Cabecera' => '\\StructType\\Cabecera',
            'Titulo' => '\\StructType\\Titulo',
            'Seccion' => '\\StructType\\Seccion',
            'Seleccion' => '\\StructType\\Seleccion',
            'Valor' => '\\StructType\\Valor',
            'Columnas' => '\\StructType\\Columnas',
            'tRespuestaConfiguracionConsulta' => '\\StructType\\TRespuestaConfiguracionConsulta',
            'RespuestaDirectorioConsultasResponse' => '\\StructType\\RespuestaDirectorioConsultasResponse',
            'tRespuestaDirectorioConsultas' => '\\StructType\\TRespuestaDirectorioConsultas',
            'Consultas' => '\\StructType\\Consultas',
        );
    }
}
