<?php

namespace EnumType;

/**
 * This class stands for tAtrSignoEne EnumType
 * Meta information extracted from the WSDL
 * - documentation: Atributo para signo
 * @subpackage Enumerations
 */
class TAtrSignoEne
{
    /**
     * Constant for value '1'
     * Meta information extracted from the WSDL
     * - documentation: derechos de cobro con energia
     * @return string '1'
     */
    const VALUE_1 = '1';
    /**
     * Constant for value '-1'
     * Meta information extracted from the WSDL
     * - documentation: obligaciones de pago con energia
     * @return string '-1'
     */
    const VALUE_1_1 = '-1';
    /**
     * Constant for value '0'
     * Meta information extracted from the WSDL
     * - documentation: DC/OP que valoran banda, o son de reparto, o son de energía a sobre coste, o son de rectificación
     * @return string '0'
     */
    const VALUE_0 = '0';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_1
     * @uses self::VALUE_1_1
     * @uses self::VALUE_0
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_1,
            self::VALUE_1_1,
            self::VALUE_0,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
