<?php

namespace EnumType;

/**
 * This class stands for tAtrUniEnergia EnumType
 * Meta information extracted from the WSDL
 * - documentation: Atributo para unidad de energía
 * @subpackage Enumerations
 */
class TAtrUniEnergia
{
    /**
     * Constant for value 'MWh'
     * Meta information extracted from the WSDL
     * - documentation: MWh
     * @return string 'MWh'
     */
    const VALUE_MWH = 'MWh';
    /**
     * Constant for value 'kWh'
     * Meta information extracted from the WSDL
     * - documentation: kWh
     * @return string 'kWh'
     */
    const VALUE_K_WH = 'kWh';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_MWH
     * @uses self::VALUE_K_WH
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_MWH,
            self::VALUE_K_WH,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
