<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Cabecera StructType
 * Meta information extracted from the WSDL
 * - documentation: Datos de cabecera de la consulta
 * @subpackage Structs
 */
class Cabecera extends AbstractStructBase
{
    /**
     * The CodConsulta
     * Meta information extracted from the WSDL
     * - documentation: Código de Consulta
     * @var \StructType\TCodConsulta
     */
    public $CodConsulta;
    /**
     * The Titulo
     * @var \StructType\Titulo
     */
    public $Titulo;
    /**
     * The TipoConsulta
     * Meta information extracted from the WSDL
     * - documentation: Tipo de Consulta
     * @var \StructType\TTipoConsulta
     */
    public $TipoConsulta;
    /**
     * The Seccion
     * @var \StructType\Seccion
     */
    public $Seccion;
    /**
     * Constructor method for Cabecera
     * @uses Cabecera::setCodConsulta()
     * @uses Cabecera::setTitulo()
     * @uses Cabecera::setTipoConsulta()
     * @uses Cabecera::setSeccion()
     * @param \StructType\TCodConsulta $codConsulta
     * @param \StructType\Titulo $titulo
     * @param \StructType\TTipoConsulta $tipoConsulta
     * @param \StructType\Seccion $seccion
     */
    public function __construct(\StructType\TCodConsulta $codConsulta = null, \StructType\Titulo $titulo = null, \StructType\TTipoConsulta $tipoConsulta = null, \StructType\Seccion $seccion = null)
    {
        $this
            ->setCodConsulta($codConsulta)
            ->setTitulo($titulo)
            ->setTipoConsulta($tipoConsulta)
            ->setSeccion($seccion);
    }
    /**
     * Get CodConsulta value
     * @return \StructType\TCodConsulta|null
     */
    public function getCodConsulta()
    {
        return $this->CodConsulta;
    }
    /**
     * Set CodConsulta value
     * @param \StructType\TCodConsulta $codConsulta
     * @return \StructType\Cabecera
     */
    public function setCodConsulta(\StructType\TCodConsulta $codConsulta = null)
    {
        $this->CodConsulta = $codConsulta;
        return $this;
    }
    /**
     * Get Titulo value
     * @return \StructType\Titulo|null
     */
    public function getTitulo()
    {
        return $this->Titulo;
    }
    /**
     * Set Titulo value
     * @param \StructType\Titulo $titulo
     * @return \StructType\Cabecera
     */
    public function setTitulo(\StructType\Titulo $titulo = null)
    {
        $this->Titulo = $titulo;
        return $this;
    }
    /**
     * Get TipoConsulta value
     * @return \StructType\TTipoConsulta|null
     */
    public function getTipoConsulta()
    {
        return $this->TipoConsulta;
    }
    /**
     * Set TipoConsulta value
     * @param \StructType\TTipoConsulta $tipoConsulta
     * @return \StructType\Cabecera
     */
    public function setTipoConsulta(\StructType\TTipoConsulta $tipoConsulta = null)
    {
        $this->TipoConsulta = $tipoConsulta;
        return $this;
    }
    /**
     * Get Seccion value
     * @return \StructType\Seccion|null
     */
    public function getSeccion()
    {
        return $this->Seccion;
    }
    /**
     * Set Seccion value
     * @param \StructType\Seccion $seccion
     * @return \StructType\Cabecera
     */
    public function setSeccion(\StructType\Seccion $seccion = null)
    {
        $this->Seccion = $seccion;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Cabecera
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
