<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Fila StructType
 * Meta information extracted from the WSDL
 * - documentation: Filas resultado de la consulta
 * @subpackage Structs
 */
class Fila extends AbstractStructBase
{
    /**
     * The Txt
     * Meta information extracted from the WSDL
     * - choice: Txt | Num | Fec | Feh | Hor
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\Txt
     */
    public $Txt;
    /**
     * The Num
     * Meta information extracted from the WSDL
     * - choice: Txt | Num | Fec | Feh | Hor
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\Num
     */
    public $Num;
    /**
     * The Fec
     * Meta information extracted from the WSDL
     * - choice: Txt | Num | Fec | Feh | Hor
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\Fec
     */
    public $Fec;
    /**
     * The Feh
     * Meta information extracted from the WSDL
     * - choice: Txt | Num | Fec | Feh | Hor
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\Feh
     */
    public $Feh;
    /**
     * The Hor
     * Meta information extracted from the WSDL
     * - choice: Txt | Num | Fec | Feh | Hor
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\Hor
     */
    public $Hor;
    /**
     * Constructor method for Fila
     * @uses Fila::setTxt()
     * @uses Fila::setNum()
     * @uses Fila::setFec()
     * @uses Fila::setFeh()
     * @uses Fila::setHor()
     * @param \StructType\Txt $txt
     * @param \StructType\Num $num
     * @param \StructType\Fec $fec
     * @param \StructType\Feh $feh
     * @param \StructType\Hor $hor
     */
    public function __construct(\StructType\Txt $txt = null, \StructType\Num $num = null, \StructType\Fec $fec = null, \StructType\Feh $feh = null, \StructType\Hor $hor = null)
    {
        $this
            ->setTxt($txt)
            ->setNum($num)
            ->setFec($fec)
            ->setFeh($feh)
            ->setHor($hor);
    }
    /**
     * Get Txt value
     * @return \StructType\Txt|null
     */
    public function getTxt()
    {
        return isset($this->Txt) ? $this->Txt : null;
    }
    /**
     * This method is responsible for validating the value passed to the setTxt method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTxt method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateTxtForChoiceConstraintsFromSetTxt($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Num',
            'Fec',
            'Feh',
            'Hor',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Txt can\'t be set as the property %s is already set. Only one property must be set among these properties: Txt, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Txt value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Txt $txt
     * @return \StructType\Fila
     */
    public function setTxt(\StructType\Txt $txt = null)
    {
        // validation for constraint: choice(Txt, Num, Fec, Feh, Hor)
        if ('' !== ($txtChoiceErrorMessage = self::validateTxtForChoiceConstraintsFromSetTxt($txt))) {
            throw new \InvalidArgumentException($txtChoiceErrorMessage, __LINE__);
        }
        if (is_null($txt) || (is_array($txt) && empty($txt))) {
            unset($this->Txt);
        } else {
            $this->Txt = $txt;
        }
        return $this;
    }
    /**
     * Get Num value
     * @return \StructType\Num|null
     */
    public function getNum()
    {
        return isset($this->Num) ? $this->Num : null;
    }
    /**
     * This method is responsible for validating the value passed to the setNum method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNum method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateNumForChoiceConstraintsFromSetNum($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Txt',
            'Fec',
            'Feh',
            'Hor',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Num can\'t be set as the property %s is already set. Only one property must be set among these properties: Num, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Num value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Num $num
     * @return \StructType\Fila
     */
    public function setNum(\StructType\Num $num = null)
    {
        // validation for constraint: choice(Txt, Num, Fec, Feh, Hor)
        if ('' !== ($numChoiceErrorMessage = self::validateNumForChoiceConstraintsFromSetNum($num))) {
            throw new \InvalidArgumentException($numChoiceErrorMessage, __LINE__);
        }
        if (is_null($num) || (is_array($num) && empty($num))) {
            unset($this->Num);
        } else {
            $this->Num = $num;
        }
        return $this;
    }
    /**
     * Get Fec value
     * @return \StructType\Fec|null
     */
    public function getFec()
    {
        return isset($this->Fec) ? $this->Fec : null;
    }
    /**
     * This method is responsible for validating the value passed to the setFec method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFec method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateFecForChoiceConstraintsFromSetFec($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Txt',
            'Num',
            'Feh',
            'Hor',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Fec can\'t be set as the property %s is already set. Only one property must be set among these properties: Fec, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Fec value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Fec $fec
     * @return \StructType\Fila
     */
    public function setFec(\StructType\Fec $fec = null)
    {
        // validation for constraint: choice(Txt, Num, Fec, Feh, Hor)
        if ('' !== ($fecChoiceErrorMessage = self::validateFecForChoiceConstraintsFromSetFec($fec))) {
            throw new \InvalidArgumentException($fecChoiceErrorMessage, __LINE__);
        }
        if (is_null($fec) || (is_array($fec) && empty($fec))) {
            unset($this->Fec);
        } else {
            $this->Fec = $fec;
        }
        return $this;
    }
    /**
     * Get Feh value
     * @return \StructType\Feh|null
     */
    public function getFeh()
    {
        return isset($this->Feh) ? $this->Feh : null;
    }
    /**
     * This method is responsible for validating the value passed to the setFeh method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFeh method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateFehForChoiceConstraintsFromSetFeh($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Txt',
            'Num',
            'Fec',
            'Hor',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Feh can\'t be set as the property %s is already set. Only one property must be set among these properties: Feh, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Feh value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Feh $feh
     * @return \StructType\Fila
     */
    public function setFeh(\StructType\Feh $feh = null)
    {
        // validation for constraint: choice(Txt, Num, Fec, Feh, Hor)
        if ('' !== ($fehChoiceErrorMessage = self::validateFehForChoiceConstraintsFromSetFeh($feh))) {
            throw new \InvalidArgumentException($fehChoiceErrorMessage, __LINE__);
        }
        if (is_null($feh) || (is_array($feh) && empty($feh))) {
            unset($this->Feh);
        } else {
            $this->Feh = $feh;
        }
        return $this;
    }
    /**
     * Get Hor value
     * @return \StructType\Hor|null
     */
    public function getHor()
    {
        return isset($this->Hor) ? $this->Hor : null;
    }
    /**
     * This method is responsible for validating the value passed to the setHor method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHor method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateHorForChoiceConstraintsFromSetHor($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Txt',
            'Num',
            'Fec',
            'Feh',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Hor can\'t be set as the property %s is already set. Only one property must be set among these properties: Hor, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Hor value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Hor $hor
     * @return \StructType\Fila
     */
    public function setHor(\StructType\Hor $hor = null)
    {
        // validation for constraint: choice(Txt, Num, Fec, Feh, Hor)
        if ('' !== ($horChoiceErrorMessage = self::validateHorForChoiceConstraintsFromSetHor($hor))) {
            throw new \InvalidArgumentException($horChoiceErrorMessage, __LINE__);
        }
        if (is_null($hor) || (is_array($hor) && empty($hor))) {
            unset($this->Hor);
        } else {
            $this->Hor = $hor;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Fila
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
