<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for IdTransaccion StructType
 * Meta information extracted from the WSDL
 * - documentation: Identificativo de Oferta, Bilateral o declaración de R.E. a distribución. Opcional según el programa.
 * @subpackage Structs
 */
class IdTransaccion extends AbstractStructBase
{
    /**
     * The v
     * Meta information extracted from the WSDL
     * - use: required
     * @var int
     */
    public $v;
    /**
     * Constructor method for IdTransaccion
     * @uses IdTransaccion::setV()
     * @param int $v
     */
    public function __construct($v = null)
    {
        $this
            ->setV($v);
    }
    /**
     * Get v value
     * @return int
     */
    public function getV()
    {
        return $this->v;
    }
    /**
     * Set v value
     * @param int $v
     * @return \StructType\IdTransaccion
     */
    public function setV($v = null)
    {
        // validation for constraint: int
        if (!is_null($v) && !(is_int($v) || ctype_digit($v))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($v, true), gettype($v)), __LINE__);
        }
        $this->v = $v;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\IdTransaccion
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
