<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for tMensajeHorasAnuladas StructType
 * Meta information extracted from the WSDL
 * - documentation: Tipo global para horas anuladas
 * @subpackage Structs
 */
class TMensajeHorasAnuladas extends AbstractStructBase
{
    /**
     * The IdMensaje
     * Meta information extracted from the WSDL
     * - documentation: Identificación del mensaje
     * @var \StructType\TId
     */
    public $IdMensaje;
    /**
     * The VerMensaje
     * Meta information extracted from the WSDL
     * - documentation: Versión del mensaje
     * @var \StructType\TVersionMensaje
     */
    public $VerMensaje;
    /**
     * The FechaMensaje
     * Meta information extracted from the WSDL
     * - documentation: Fecha y hora de generación de los datos para el mensaje (no de envío del mensaje en sí)
     * @var \StructType\TFechaHora
     */
    public $FechaMensaje;
    /**
     * The IdRemitente
     * Meta information extracted from the WSDL
     * - documentation: Código del emisor que envía el mensaje (OM u OS)
     * @var \StructType\TIdRemitente
     */
    public $IdRemitente;
    /**
     * The IdHorasAnuladas
     * @var \StructType\IdHorasAnuladas
     */
    public $IdHorasAnuladas;
    /**
     * The TipoMercado
     * Meta information extracted from the WSDL
     * - documentation: MI: Mercado Intradiario
     * @var \StructType\TMercado
     */
    public $TipoMercado;
    /**
     * The Sesion
     * @var \StructType\Sesion
     */
    public $Sesion;
    /**
     * The SerieTemporal
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TSerieTemporalHorasAnuladas
     */
    public $SerieTemporal;
    /**
     * Constructor method for tMensajeHorasAnuladas
     * @uses TMensajeHorasAnuladas::setIdMensaje()
     * @uses TMensajeHorasAnuladas::setVerMensaje()
     * @uses TMensajeHorasAnuladas::setFechaMensaje()
     * @uses TMensajeHorasAnuladas::setIdRemitente()
     * @uses TMensajeHorasAnuladas::setIdHorasAnuladas()
     * @uses TMensajeHorasAnuladas::setTipoMercado()
     * @uses TMensajeHorasAnuladas::setSesion()
     * @uses TMensajeHorasAnuladas::setSerieTemporal()
     * @param \StructType\TId $idMensaje
     * @param \StructType\TVersionMensaje $verMensaje
     * @param \StructType\TFechaHora $fechaMensaje
     * @param \StructType\TIdRemitente $idRemitente
     * @param \StructType\IdHorasAnuladas $idHorasAnuladas
     * @param \StructType\TMercado $tipoMercado
     * @param \StructType\Sesion $sesion
     * @param \StructType\TSerieTemporalHorasAnuladas $serieTemporal
     */
    public function __construct(\StructType\TId $idMensaje = null, \StructType\TVersionMensaje $verMensaje = null, \StructType\TFechaHora $fechaMensaje = null, \StructType\TIdRemitente $idRemitente = null, \StructType\IdHorasAnuladas $idHorasAnuladas = null, \StructType\TMercado $tipoMercado = null, \StructType\Sesion $sesion = null, \StructType\TSerieTemporalHorasAnuladas $serieTemporal = null)
    {
        $this
            ->setIdMensaje($idMensaje)
            ->setVerMensaje($verMensaje)
            ->setFechaMensaje($fechaMensaje)
            ->setIdRemitente($idRemitente)
            ->setIdHorasAnuladas($idHorasAnuladas)
            ->setTipoMercado($tipoMercado)
            ->setSesion($sesion)
            ->setSerieTemporal($serieTemporal);
    }
    /**
     * Get IdMensaje value
     * @return \StructType\TId|null
     */
    public function getIdMensaje()
    {
        return $this->IdMensaje;
    }
    /**
     * Set IdMensaje value
     * @param \StructType\TId $idMensaje
     * @return \StructType\TMensajeHorasAnuladas
     */
    public function setIdMensaje(\StructType\TId $idMensaje = null)
    {
        $this->IdMensaje = $idMensaje;
        return $this;
    }
    /**
     * Get VerMensaje value
     * @return \StructType\TVersionMensaje|null
     */
    public function getVerMensaje()
    {
        return $this->VerMensaje;
    }
    /**
     * Set VerMensaje value
     * @param \StructType\TVersionMensaje $verMensaje
     * @return \StructType\TMensajeHorasAnuladas
     */
    public function setVerMensaje(\StructType\TVersionMensaje $verMensaje = null)
    {
        $this->VerMensaje = $verMensaje;
        return $this;
    }
    /**
     * Get FechaMensaje value
     * @return \StructType\TFechaHora|null
     */
    public function getFechaMensaje()
    {
        return $this->FechaMensaje;
    }
    /**
     * Set FechaMensaje value
     * @param \StructType\TFechaHora $fechaMensaje
     * @return \StructType\TMensajeHorasAnuladas
     */
    public function setFechaMensaje(\StructType\TFechaHora $fechaMensaje = null)
    {
        $this->FechaMensaje = $fechaMensaje;
        return $this;
    }
    /**
     * Get IdRemitente value
     * @return \StructType\TIdRemitente|null
     */
    public function getIdRemitente()
    {
        return $this->IdRemitente;
    }
    /**
     * Set IdRemitente value
     * @param \StructType\TIdRemitente $idRemitente
     * @return \StructType\TMensajeHorasAnuladas
     */
    public function setIdRemitente(\StructType\TIdRemitente $idRemitente = null)
    {
        $this->IdRemitente = $idRemitente;
        return $this;
    }
    /**
     * Get IdHorasAnuladas value
     * @return \StructType\IdHorasAnuladas|null
     */
    public function getIdHorasAnuladas()
    {
        return $this->IdHorasAnuladas;
    }
    /**
     * Set IdHorasAnuladas value
     * @param \StructType\IdHorasAnuladas $idHorasAnuladas
     * @return \StructType\TMensajeHorasAnuladas
     */
    public function setIdHorasAnuladas(\StructType\IdHorasAnuladas $idHorasAnuladas = null)
    {
        $this->IdHorasAnuladas = $idHorasAnuladas;
        return $this;
    }
    /**
     * Get TipoMercado value
     * @return \StructType\TMercado|null
     */
    public function getTipoMercado()
    {
        return $this->TipoMercado;
    }
    /**
     * Set TipoMercado value
     * @param \StructType\TMercado $tipoMercado
     * @return \StructType\TMensajeHorasAnuladas
     */
    public function setTipoMercado(\StructType\TMercado $tipoMercado = null)
    {
        $this->TipoMercado = $tipoMercado;
        return $this;
    }
    /**
     * Get Sesion value
     * @return \StructType\Sesion|null
     */
    public function getSesion()
    {
        return $this->Sesion;
    }
    /**
     * Set Sesion value
     * @param \StructType\Sesion $sesion
     * @return \StructType\TMensajeHorasAnuladas
     */
    public function setSesion(\StructType\Sesion $sesion = null)
    {
        $this->Sesion = $sesion;
        return $this;
    }
    /**
     * Get SerieTemporal value
     * @return \StructType\TSerieTemporalHorasAnuladas|null
     */
    public function getSerieTemporal()
    {
        return $this->SerieTemporal;
    }
    /**
     * Set SerieTemporal value
     * @param \StructType\TSerieTemporalHorasAnuladas $serieTemporal
     * @return \StructType\TMensajeHorasAnuladas
     */
    public function setSerieTemporal(\StructType\TSerieTemporalHorasAnuladas $serieTemporal = null)
    {
        $this->SerieTemporal = $serieTemporal;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TMensajeHorasAnuladas
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
