<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for tMercado StructType
 * Meta information extracted from the WSDL
 * - documentation: Tipo de mercado
 * @subpackage Structs
 */
class TMercado extends AbstractStructBase
{
    /**
     * The v
     * Meta information extracted from the WSDL
     * - use: required
     * @var string
     */
    public $v;
    /**
     * Constructor method for tMercado
     * @uses TMercado::setV()
     * @param string $v
     */
    public function __construct($v = null)
    {
        $this
            ->setV($v);
    }
    /**
     * Get v value
     * @return string
     */
    public function getV()
    {
        return $this->v;
    }
    /**
     * Set v value
     * @uses \EnumType\TAtrMercado::valueIsValid()
     * @uses \EnumType\TAtrMercado::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $v
     * @return \StructType\TMercado
     */
    public function setV($v = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\TAtrMercado::valueIsValid($v)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\TAtrMercado', is_array($v) ? implode(', ', $v) : var_export($v, true), implode(', ', \EnumType\TAtrMercado::getValidValues())), __LINE__);
        }
        $this->v = $v;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TMercado
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
