<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for tPeriodoHorasAnuladas StructType
 * Meta information extracted from the WSDL
 * - documentation: Periodo de la sesión
 * @subpackage Structs
 */
class TPeriodoHorasAnuladas extends AbstractStructBase
{
    /**
     * The Dia
     * Meta information extracted from the WSDL
     * - documentation: Fecha del Periodo
     * @var \StructType\TFecha
     */
    public $Dia;
    /**
     * The Val
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\TValHorasAnuladas[]
     */
    public $Val;
    /**
     * Constructor method for tPeriodoHorasAnuladas
     * @uses TPeriodoHorasAnuladas::setDia()
     * @uses TPeriodoHorasAnuladas::setVal()
     * @param \StructType\TFecha $dia
     * @param \StructType\TValHorasAnuladas[] $val
     */
    public function __construct(\StructType\TFecha $dia = null, array $val = array())
    {
        $this
            ->setDia($dia)
            ->setVal($val);
    }
    /**
     * Get Dia value
     * @return \StructType\TFecha|null
     */
    public function getDia()
    {
        return $this->Dia;
    }
    /**
     * Set Dia value
     * @param \StructType\TFecha $dia
     * @return \StructType\TPeriodoHorasAnuladas
     */
    public function setDia(\StructType\TFecha $dia = null)
    {
        $this->Dia = $dia;
        return $this;
    }
    /**
     * Get Val value
     * @return \StructType\TValHorasAnuladas[]|null
     */
    public function getVal()
    {
        return $this->Val;
    }
    /**
     * This method is responsible for validating the values passed to the setVal method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVal method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateValForArrayConstraintsFromSetVal(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tPeriodoHorasAnuladasValItem) {
            // validation for constraint: itemType
            if (!$tPeriodoHorasAnuladasValItem instanceof \StructType\TValHorasAnuladas) {
                $invalidValues[] = is_object($tPeriodoHorasAnuladasValItem) ? get_class($tPeriodoHorasAnuladasValItem) : sprintf('%s(%s)', gettype($tPeriodoHorasAnuladasValItem), var_export($tPeriodoHorasAnuladasValItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Val property can only contain items of type \StructType\TValHorasAnuladas, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Val value
     * @throws \InvalidArgumentException
     * @param \StructType\TValHorasAnuladas[] $val
     * @return \StructType\TPeriodoHorasAnuladas
     */
    public function setVal(array $val = array())
    {
        // validation for constraint: array
        if ('' !== ($valArrayErrorMessage = self::validateValForArrayConstraintsFromSetVal($val))) {
            throw new \InvalidArgumentException($valArrayErrorMessage, __LINE__);
        }
        $this->Val = $val;
        return $this;
    }
    /**
     * Add item to Val value
     * @throws \InvalidArgumentException
     * @param \StructType\TValHorasAnuladas $item
     * @return \StructType\TPeriodoHorasAnuladas
     */
    public function addToVal(\StructType\TValHorasAnuladas $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TValHorasAnuladas) {
            throw new \InvalidArgumentException(sprintf('The Val property can only contain items of type \StructType\TValHorasAnuladas, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Val[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TPeriodoHorasAnuladas
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
