<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for tRespuestaConfiguracionConsulta StructType
 * Meta information extracted from the WSDL
 * - documentation: Tipo básico para respuesta a la configuración de una consulta
 * @subpackage Structs
 */
class TRespuestaConfiguracionConsulta extends AbstractStructBase
{
    /**
     * The Cabecera
     * Meta information extracted from the WSDL
     * - ref: om:Cabecera
     * @var \StructType\Cabecera
     */
    public $Cabecera;
    /**
     * The Parametros
     * Meta information extracted from the WSDL
     * - ref: om:Parametros
     * @var \StructType\Parametros
     */
    public $Parametros;
    /**
     * The Columnas
     * Meta information extracted from the WSDL
     * - ref: om:Columnas
     * @var \StructType\Columnas
     */
    public $Columnas;
    /**
     * Constructor method for tRespuestaConfiguracionConsulta
     * @uses TRespuestaConfiguracionConsulta::setCabecera()
     * @uses TRespuestaConfiguracionConsulta::setParametros()
     * @uses TRespuestaConfiguracionConsulta::setColumnas()
     * @param \StructType\Cabecera $cabecera
     * @param \StructType\Parametros $parametros
     * @param \StructType\Columnas $columnas
     */
    public function __construct(\StructType\Cabecera $cabecera = null, \StructType\Parametros $parametros = null, \StructType\Columnas $columnas = null)
    {
        $this
            ->setCabecera($cabecera)
            ->setParametros($parametros)
            ->setColumnas($columnas);
    }
    /**
     * Get Cabecera value
     * @return \StructType\Cabecera|null
     */
    public function getCabecera()
    {
        return $this->Cabecera;
    }
    /**
     * Set Cabecera value
     * @param \StructType\Cabecera $cabecera
     * @return \StructType\TRespuestaConfiguracionConsulta
     */
    public function setCabecera(\StructType\Cabecera $cabecera = null)
    {
        $this->Cabecera = $cabecera;
        return $this;
    }
    /**
     * Get Parametros value
     * @return \StructType\Parametros|null
     */
    public function getParametros()
    {
        return $this->Parametros;
    }
    /**
     * Set Parametros value
     * @param \StructType\Parametros $parametros
     * @return \StructType\TRespuestaConfiguracionConsulta
     */
    public function setParametros(\StructType\Parametros $parametros = null)
    {
        $this->Parametros = $parametros;
        return $this;
    }
    /**
     * Get Columnas value
     * @return \StructType\Columnas|null
     */
    public function getColumnas()
    {
        return $this->Columnas;
    }
    /**
     * Set Columnas value
     * @param \StructType\Columnas $columnas
     * @return \StructType\TRespuestaConfiguracionConsulta
     */
    public function setColumnas(\StructType\Columnas $columnas = null)
    {
        $this->Columnas = $columnas;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TRespuestaConfiguracionConsulta
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
