<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for tRespuestaDirectorioConsultas StructType
 * Meta information extracted from the WSDL
 * - documentation: Tipo complejo para la respuesta del directorio de las Consultas Disponibles
 * @subpackage Structs
 */
class TRespuestaDirectorioConsultas extends AbstractStructBase
{
    /**
     * The Seccion
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Seccion[]
     */
    public $Seccion;
    /**
     * Constructor method for tRespuestaDirectorioConsultas
     * @uses TRespuestaDirectorioConsultas::setSeccion()
     * @param \StructType\Seccion[] $seccion
     */
    public function __construct(array $seccion = array())
    {
        $this
            ->setSeccion($seccion);
    }
    /**
     * Get Seccion value
     * @return \StructType\Seccion[]|null
     */
    public function getSeccion()
    {
        return $this->Seccion;
    }
    /**
     * This method is responsible for validating the values passed to the setSeccion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeccion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeccionForArrayConstraintsFromSetSeccion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $tRespuestaDirectorioConsultasSeccionItem) {
            // validation for constraint: itemType
            if (!$tRespuestaDirectorioConsultasSeccionItem instanceof \StructType\Seccion) {
                $invalidValues[] = is_object($tRespuestaDirectorioConsultasSeccionItem) ? get_class($tRespuestaDirectorioConsultasSeccionItem) : sprintf('%s(%s)', gettype($tRespuestaDirectorioConsultasSeccionItem), var_export($tRespuestaDirectorioConsultasSeccionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Seccion property can only contain items of type \StructType\Seccion, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Seccion value
     * @throws \InvalidArgumentException
     * @param \StructType\Seccion[] $seccion
     * @return \StructType\TRespuestaDirectorioConsultas
     */
    public function setSeccion(array $seccion = array())
    {
        // validation for constraint: array
        if ('' !== ($seccionArrayErrorMessage = self::validateSeccionForArrayConstraintsFromSetSeccion($seccion))) {
            throw new \InvalidArgumentException($seccionArrayErrorMessage, __LINE__);
        }
        $this->Seccion = $seccion;
        return $this;
    }
    /**
     * Add item to Seccion value
     * @throws \InvalidArgumentException
     * @param \StructType\Seccion $item
     * @return \StructType\TRespuestaDirectorioConsultas
     */
    public function addToSeccion(\StructType\Seccion $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Seccion) {
            throw new \InvalidArgumentException(sprintf('The Seccion property can only contain items of type \StructType\Seccion, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Seccion[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TRespuestaDirectorioConsultas
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
