<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for tValPrograma StructType
 * Meta information extracted from the WSDL
 * - documentation: Describe un valor individual de hora y energía
 * @subpackage Structs
 */
class TValPrograma extends AbstractStructBase
{
    /**
     * The Per
     * Meta information extracted from the WSDL
     * - documentation: Secuencial dentro del Intervalo. Indica el periodo horario dentro del día. No incluir para aquellos periodos que no tienen programa.
     * @var \StructType\TPeriodo
     */
    public $Per;
    /**
     * The Ctn
     * Meta information extracted from the WSDL
     * - documentation: Valor de Energía
     * @var \StructType\TCantidad
     */
    public $Ctn;
    /**
     * Constructor method for tValPrograma
     * @uses TValPrograma::setPer()
     * @uses TValPrograma::setCtn()
     * @param \StructType\TPeriodo $per
     * @param \StructType\TCantidad $ctn
     */
    public function __construct(\StructType\TPeriodo $per = null, \StructType\TCantidad $ctn = null)
    {
        $this
            ->setPer($per)
            ->setCtn($ctn);
    }
    /**
     * Get Per value
     * @return \StructType\TPeriodo|null
     */
    public function getPer()
    {
        return $this->Per;
    }
    /**
     * Set Per value
     * @param \StructType\TPeriodo $per
     * @return \StructType\TValPrograma
     */
    public function setPer(\StructType\TPeriodo $per = null)
    {
        $this->Per = $per;
        return $this;
    }
    /**
     * Get Ctn value
     * @return \StructType\TCantidad|null
     */
    public function getCtn()
    {
        return $this->Ctn;
    }
    /**
     * Set Ctn value
     * @param \StructType\TCantidad $ctn
     * @return \StructType\TValPrograma
     */
    public function setCtn(\StructType\TCantidad $ctn = null)
    {
        $this->Ctn = $ctn;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TValPrograma
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
